package ui;

import java.awt.event.*;
import java.awt.*;
import java.util.*;


class MainPanel extends Panel implements ButtonsInterface{

	MainPanel(){
		MouseDispatcher mouseDispatcher = new MouseDispatcher();
		addMouseListener(mouseDispatcher);
		addMouseMotionListener(mouseDispatcher);
		
		init_robots();
		
		
	}
	
	
	

	public Choice choice = new Choice();
	
	public void initializeButtons(Buttons buttons){
		choice = new Choice();
		for(int i=0; i<N_ROBOTS; i++)
			choice.add(""+i);
		buttons.add(choice);
		
		buttons.addButton("move");
		buttons.addButton("stop");
		buttons.addButton("left_turn");
		buttons.addButton("right_turn");
		buttons.addButton("stop_turn");
		buttons.addButton("on");
		buttons.addButton("off");
	}
	public void buttonPressed(String label){
		int id = choice.getSelectedIndex();
		Robot robot = (Robot) robots.get(id);
		
		if (label.equals("move"))
			robot.start_move();			// moves 10 (+- 2) pixels / tick while moving
		else if (label.equals("stop"))
			robot.stop_move();
		else if (label.equals("left_turn"))
			robot.start_turn_left();	// turns 10 (+- 2) degrees / tick while turning
		else if (label.equals("right_turn"))
			robot.start_turn_right();	// turns 10 (+- 2) degrees / tick while turning
		else if (label.equals("stop_turn"))
			robot.stop_turn();
		else if (label.equals("on"))
			robot.turn_on();
		else if (label.equals("off"))
			robot.turn_off();
		repaint();
	}	
	
	
	
	
	
	
	
	
	Image buffered_image = null;
	public void update(Graphics g) {
		paint(g);
	}
	public void paint(Graphics g) {

			//double buffering
			if (buffered_image == null)
				buffered_image = createImage(getSize().width, getSize().height);
			Graphics bg = buffered_image.getGraphics();

			// clear
			bg.setColor(new Color(158,255,158));
			bg.fillRect(0,0, getSize().width, getSize().height);

			// paint code!
			paint_robots(bg);
			
			//double buffering
			bg.dispose();
      
			g.drawImage(buffered_image,0,0,this);
		
	}
	
   
	
	
	
	
	//
	// Do not change
	//
	public int N_ROBOTS = 5;
	ArrayList robots = new ArrayList();
	public void init_robots(){
		for(int i=0; i<N_ROBOTS; i++){
			Robot robot = new Robot();
			robots.add(robot);
			robot.id = i;
		}
		(new MyThread()).start();
		start_time = System.currentTimeMillis();
	}
	public void paint_robots(Graphics g){
			for(int i=0; i<robots.size(); i++){
				Robot robot = (Robot) robots.get(i);
				robot.paint(g);
			}
			g.setColor(Color.red);
			int r = 80;
			g.drawOval(300-r, 250-r, 2*r, 2*r);
			
			if (!finished())
				time = (int)(System.currentTimeMillis()-start_time);
			g.setFont(new Font("Helvetica", 0, 40));
			g.drawString(""+(time/100)/10.0, 0, 40);
	}		
	long start_time;
	int time;
	public boolean finished(){
		for(int i=0; i<robots.size(); i++){
			Robot robot = (Robot) robots.get(i);
			if (!robot.inside_goal_circle(300,250,80))
				return false;
		}
		return true;
	}
	public void tick(){
		// robot moves 10 (+- 2) pixels / tick
		// robot turns 10 (+- 2) degrees / tick
		for(int i=0; i<robots.size(); i++){
			Robot robot = (Robot) robots.get(i);
			robot.tick();
		}
		repaint();
	}
	class MyThread extends Thread {
		public void run(){
			while(true){
				try{
				this.sleep(100);
				}
				catch(Exception e){e.printStackTrace();}
				tick();
			}
		}
	}
	//
	//
	//
	
	
	
	
	

	
	
	
	
   
	
	public int operation_status;
	public static final int NONE = 0;
	public static final int DRAWING = 1;
   
	//   
	// central event dispatcher
	//
	public class MouseDispatcher 
		extends MouseAdapter implements MouseMotionListener{

  		public void mouseMoved(MouseEvent e) {
  		}
  		public void mousePressed(MouseEvent e) {
			
			Point p = e.getPoint();
			boolean right_button = (e.getModifiers() & e.BUTTON3_MASK) != 0;
			
			operation_status = DRAWING;
		}
  		public void mouseDragged(MouseEvent e) {
			Point p = e.getPoint();
			
			switch(operation_status){
			case DRAWING:
				break;
			}
			
   		}
		public void mouseReleased(MouseEvent e) {
			Point p = e.getPoint();
			
			switch(operation_status){
			case DRAWING:
				break;
			}
		}
		public void mouseClicked(MouseEvent e){
		}
    }
}







